# Database Population

This repository maintains JSON files of all roles, subroles, and permissions.  To modify any of these entities in the 
local database, simply make the changes to the JSON files and run the migration script.  The migration script runs 
automatically during deployments to update the database.

## Runing the Script

To run the script to populate all entities locally:

    python migrate_v2_entities.py -e localdev --all
    
To run the script during a deployment on a live environment, use the `--plan` flag and verify that the changes being
made are correct.  Unintended changes to roles, subroles, or permissions can effectively bring down an environment by 
preventing users from getting the permissions that allow them to perform API requests.
    
    python migrate_v2_entities.py -e <env> --all --plan
    python migrate_v2_entities.py -e <env> --all
    
Options:
    
`-e`: Specify the environment (localdev, dev01, dev08).  
`-r`: Specify while roles to modify.  
`-p`: Specify which permissions to modify.  
`-s`: Specify which subroles to modify.  
`--all`: Apply all changes to subroles, roles, and permissions.  
`--plan`: Do not make any changes, just output the changes that will be made.  
`--verbose`: Verbose

Note: roles and subroles will always be updated regardless of whether or not the JSON and database entities match 

